# =====================================================================
#  Written by and copyright Carlo Strozzi <carlos@linux.it>.
#
#  tablelib.awk: table AWK functions for CSA.
#  Copyright (C) 2001-2002 Carlo Strozzi <carlos@linux.it>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
#
# ChangeLog:
#
# * Development code
#   2002-09-13 Carlo Strozzi <carlos@linux.it>
#
# =====================================================================

# =====================================================================
# CSA table functions.
# =====================================================================

# =====================================================================
# csaTblEncode(s_string)
#
# Encodes table special characters \t, and \n in the input string.
# =====================================================================

function csaTblEncode(s_string) {

   gsub(/\n/, "\\n", s_string)
   gsub(/\t/, "\\t", s_string)

   return s_string
}

# =====================================================================
# csaTblDecode(s_string)
#
# This is the inverse of csaTblEncode().
# =====================================================================

function csaTblDecode(s,		S,i,s_length,a,escaped) {
  s_length = split(s, a, "")
  s_length++				# Cope with s_length==1
  while ( ++i <= s_length ) {
    if ( a[i] == "\\" && !escaped ) { escaped = 1; continue }
    if ( a[i] == "n" && escaped ) { S = S "\n"; escaped = 0; continue }
    if ( a[i] == "t" && escaped ) { S = S "\t"; escaped = 0; continue }
    if ( escaped ) { S = S "\\" a[i]; escaped = 0; continue }
    S = S a[i]
  }
  return S
}

# =====================================================================
# End of tablelib.awk
# =====================================================================
