# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2004,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _fault.awk,v 1.2 2006/03/10 21:36:17 carlo Exp $
# =====================================================================
# int _fault(string args [, string ofile])
#
# This is a front-end to _wwwexit(_EXITFAULT) and it may seem trivial
# at a first glance. In fact it is quite important and it is the only
# function that should be used from within _userproc() to change the
# course of the template processing in being, and take a different
# route thanks to the underlying CSA_TPLWB mechanism. That's because
# the latter should not be used with any 'csaExit.*' other than
# 'csaExit.fault', as all other underlying 'csaExit.*' types raise a
# number of issues when run by the CSA_TPLWB script, like duplicated
# HTTP headers and endless loops in some cases. Note that _userproc()
# should always call this function as an argument to return(), i.e.
# either as 'return(_fault(args))' or 'return _fault(args)'.
# =====================================================================

function _fault(args,ofile) {

  return(_wwwexit(_EXITFAULT,args,ofile))
}

