# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _hdrtocgi.awk,v 1.2 2006/03/10 21:36:17 carlo Exp $
# =====================================================================
# string _hdrtocgi(string hdr)
#
# Encode "=" and "&" characters in HTTP headers (including cookies), so
# that they can be appended to the QUERY_STRING and handled by decode()
#
# CSA HTTP custom headers (X-something) will have their names turned
# into upper-case, and with invalid characters changed into underscores
# =====================================================================

function _hdrtocgi(hdr,			a,name,i,result,uc) {

   name = 1

   # remove leading blanks from names.
   sub(/^ +/, "", hdr); gsub(/; */, ";", hdr)

   i = split(hdr, a, "")
   
   # test if custom HTTP header.
   if (a[1] ~ /[Xx]/ && a[2] == "-") uc = 1
   else uc = 0

   a[0] = i

   for (i=1; i<=a[0]; i++) {

      if (a[i] == ";") {
	 # test if custom HTTP header.
	 if (a[i+1] ~ /[Xx]/ && a[i+2] == "-") uc = 1
	 else uc = 0
	 if (i < a[0]) {
	    result = result "&"
	    name = 1
	    continue
	 }
      }
      if (a[i] == "=") {
	 if (name) name = 0
	 else a[i] = "%3D"
      }
      else if (name && a[i] !~ /[A-Za-z0-9]/) a[i] = "_"
      else if (!name && a[i] == " ") a[i] = "%20"
      else if (a[i] == "&") a[i] = "%26"

      # Turn field name into upper-case, unless requested otherwise.
      if (name && uc) result = result toupper(a[i])
      else result = result a[i]
   }

   return result
}

