# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2004,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _request.awk,v 1.2 2006/03/10 21:36:17 carlo Exp $
# =====================================================================
# anytype _request(string name [,int element])
#
# Read the value of 'name' from the list of name/value pairs received
# through the CGI interface. Non-CGI and CSA CGI special names can be
# assessed by looking them up in ENVIRON[] directly. Since 'name' is
# usually an rc(1) list of one or more values, if 'element' is not
# specified, or it is '0', then then the whole list is returned, in the
# form of a scalar (with possibly embedded \001's; if 'element' is > 0
# then the corresponding element, if available, is returns; if 'element'
# is < 0 then the last element is returned. If the requested name and/or
# element do not exist, then _ERRNO is set and a null value is returned.
# This is to enable the caller to cope with variable-length argument
# lists simply by doing something like:
#
#   var = _request("arg1",1)
#   if (_ERRNO == _EINVAL) print "argument arg1.1 does not exist!"
#
# =====================================================================

function _request(name,element,			a,i) {

  if ((element+=0) == 0) return ENVIRON["WWW_" name]
  if ((i=split(ENVIRON["WWW_" name], a, "\001")) == 0 || \
					element > i) _ERRNO = _EINVAL
  else _ERRNO = 0			# Always reset if not needed!
  if (element < 0) return a[i]
  else return a[element]
}

